osgManipulator::Dragger Class Reference

`#include <Dragger>`

Inheritance diagram for osgManipulator::Dragger:

## Public Types

typedef std::vector< osg::ref_ptr< Constraint > > | Constraints
typedef std::vector< osg::ref_ptr< DraggerCallback > > | DraggerCallbacks
Public Types inherited from osg::Transform
enum | ReferenceFrame { RELATIVE_RF , ABSOLUTE_RF , ABSOLUTE_RF_INHERIT_VIEWPOINT }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| META_Node (osgManipulator, Dragger)
virtual void | setParentDragger (Dragger *parent)
Dragger * | getParentDragger ()
const Dragger * | getParentDragger () const
virtual const CompositeDragger * | getComposite () const
virtual CompositeDragger * | getComposite ()
void | setHandleEvents (bool flag)
bool | getHandleEvents () const
void | setActivationModKeyMask (unsigned int mask)
unsigned int | getActivationModKeyMask () const
void | setActivationMouseButtonMask (unsigned int mask)
unsigned int | getActivationMouseButtonMask () const
void | setActivationKeyEvent (int key)
int | getActivationKeyEvent () const
virtual void | traverse (osg::NodeVisitor &nv)
virtual bool | handle (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &aa)
virtual bool | handle (const PointerInfo &, const osgGA::GUIEventAdapter &, osgGA::GUIActionAdapter &)
void | addConstraint (Constraint *constraint)
template<class T>
void | addConstraint (const osg::ref_ptr< T > &c)
void | removeConstraint (Constraint *constraint)
template<class T>
void | removeConstraint (const osg::ref_ptr< T > &c)
Constraints & | getConstraints ()
const Constraints & | getConstraints () const
void | addDraggerCallback (DraggerCallback *dc)
template<class T>
void | addDraggerCallback (const osg::ref_ptr< T > &dc)
void | removeDraggerCallback (DraggerCallback *dc)
template<class T>
void | removeDraggerCallback (const osg::ref_ptr< T > &dc)
DraggerCallbacks & | getDraggerCallbacks ()
const DraggerCallbacks & | getDraggerCallbacks () const
void | addTransformUpdating (MatrixTransform *transform, int handleCommandMask=DraggerTransformCallback::HANDLE_ALL)
void | removeTransformUpdating (MatrixTransform *transform)
virtual void | setupDefaultGeometry ()
virtual bool | receive (const MotionCommand &command)
virtual void | dispatch (MotionCommand &command)
void | setDraggerActive (bool active)
bool | getDraggerActive () const
virtual void | setIntersectionMask (osg::Node::NodeMask intersectionMask)
osg::Node::NodeMask | getIntersectionMask () const
bool | inverted () const
void | applyAppropriateFrontFace (osg::StateSet *ss) const
Public Member Functions inherited from osg::MatrixTransform
| MatrixTransform ()
| MatrixTransform (const MatrixTransform &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| MatrixTransform (const Matrix &matix)
| META_Node (osg, MatrixTransform)
virtual MatrixTransform * | asMatrixTransform ()
virtual const MatrixTransform * | asMatrixTransform () const
void | setMatrix (const Matrix &mat)
const Matrix & | getMatrix () const
void | preMult (const Matrix &mat)
void | postMult (const Matrix &mat)
const Matrix & | getInverseMatrix () const
virtual bool | computeLocalToWorldMatrix (Matrix &matrix, NodeVisitor *) const
virtual bool | computeWorldToLocalMatrix (Matrix &matrix, NodeVisitor *) const
Public Member Functions inherited from osg::Transform
| Transform ()
| Transform (const Transform &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Transform)
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual PositionAttitudeTransform * | asPositionAttitudeTransform ()
virtual const PositionAttitudeTransform * | asPositionAttitudeTransform () const
virtual AutoTransform * | asAutoTransform ()
virtual const AutoTransform * | asAutoTransform () const
void | setReferenceFrame (ReferenceFrame rf)
ReferenceFrame | getReferenceFrame () const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

| Dragger ()
| Dragger (const Dragger &rhs, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~Dragger ()
Protected Member Functions inherited from osg::MatrixTransform
virtual | ~MatrixTransform ()
Protected Member Functions inherited from osg::Transform
virtual | ~Transform ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

bool | _handleEvents
bool | _draggerActive
unsigned int | _activationModKeyMask
unsigned int | _activationMouseButtonMask
int | _activationKeyEvent
bool | _activationPermittedByModKeyMask
bool | _activationPermittedByMouseButtonMask
bool | _activationPermittedByKeyEvent
osgManipulator::PointerInfo | _pointer
Dragger * | _parentDragger
osg::ref_ptr< DraggerCallback > | _selfUpdater
Constraints | _constraints
DraggerCallbacks | _draggerCallbacks
osg::Node::NodeMask | _intersectionMask
Protected Attributes inherited from osg::MatrixTransform
Matrix | _matrix
Matrix | _inverse
bool | _inverseDirty
Protected Attributes inherited from osg::Transform
ReferenceFrame | _referenceFrame
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Base class for draggers. Concrete draggers implement the pick event handler and generate motion commands (translate, rotate, ...) and sends these command to all the DraggerCallbacks & Transforms that are connected to the Dragger that generates the commands.

## Member Typedef Documentation

## Constraints

typedef std::vector< osg::ref_ptr<Constraint> > osgManipulator::Dragger::Constraints

## DraggerCallbacks

typedef std::vector< osg::ref_ptr<DraggerCallback> > osgManipulator::Dragger::DraggerCallbacks

## Constructor & Destructor Documentation

## Dragger() [1/2]

osgManipulator::Dragger::Dragger | ( |  | ) |

protected

Referenced by osgManipulator::CompositeDragger::addDragger(), osgManipulator::CompositeDragger::containsDragger(), Dragger(), osgManipulator::CompositeDragger::findDragger(), osgManipulator::CompositeDragger::getDragger(), osgManipulator::CompositeDragger::getDragger(), getParentDragger(), getParentDragger(), META_Node(), osgManipulator::CompositeDragger::removeDragger(), osgManipulator::CompositeDragger::setParentDragger(), and setParentDragger().

## Dragger() [2/2]

osgManipulator::Dragger::Dragger | ( | const Dragger & | rhs,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

protected

References Dragger(), and osg::CopyOp::SHALLOW_COPY.

## ~Dragger()

virtual osgManipulator::Dragger::~Dragger | ( |  | ) |

protected virtual

## Member Function Documentation

## addConstraint() [1/2]

template<class T>

void osgManipulator::Dragger::addConstraint | ( | const osg::ref_ptr< T > & | c | ) |

inline

References addConstraint(), and osg::ref_ptr< T >::get().

Referenced by addConstraint().

## addConstraint() [2/2]

void osgManipulator::Dragger::addConstraint | ( | Constraint * | constraint | ) |

Referenced by osgManipulator::CommandManager::connect().

## addDraggerCallback() [1/2]

template<class T>

void osgManipulator::Dragger::addDraggerCallback | ( | const osg::ref_ptr< T > & | dc | ) |

inline

References addDraggerCallback(), and osg::ref_ptr< T >::get().

Referenced by addDraggerCallback().

## addDraggerCallback() [2/2]

void osgManipulator::Dragger::addDraggerCallback | ( | DraggerCallback * | dc | ) |

## addTransformUpdating()

void osgManipulator::Dragger::addTransformUpdating | ( | MatrixTransform * | transform,
|  | int | handleCommandMask = DraggerTransformCallback::HANDLE_ALL )

References osgManipulator::DraggerTransformCallback::HANDLE_ALL, and osg::MatrixTransform::MatrixTransform().

Referenced by osgManipulator::CommandManager::connect().

## applyAppropriateFrontFace()

void osgManipulator::Dragger::applyAppropriateFrontFace | ( | osg::StateSet * | ss | ) | const

apply the appropriate FrontFace setting to provided StateSet to ensure that the rendering of hull of the volume is the correct orientation.

## dispatch()

virtual void osgManipulator::Dragger::dispatch | ( | MotionCommand & | command | ) |

virtual

## getActivationKeyEvent()

int osgManipulator::Dragger::getActivationKeyEvent | ( |  | ) | const

inline

References _activationKeyEvent.

## getActivationModKeyMask()

unsigned int osgManipulator::Dragger::getActivationModKeyMask | ( |  | ) | const

inline

References _activationModKeyMask.

## getActivationMouseButtonMask()

unsigned int osgManipulator::Dragger::getActivationMouseButtonMask | ( |  | ) | const

inline

References _activationMouseButtonMask.

## getComposite() [1/2]

virtual CompositeDragger * osgManipulator::Dragger::getComposite | ( |  | ) |

inline virtual

Returns 0 if this Dragger is not a CompositeDragger.

Reimplemented in osgManipulator::CompositeDragger.

## getComposite() [2/2]

virtual const CompositeDragger * osgManipulator::Dragger::getComposite | ( |  | ) | const

inline virtual

Returns 0 if this Dragger is not a CompositeDragger.

Reimplemented in osgManipulator::CompositeDragger.

## getConstraints() [1/2]

Constraints & osgManipulator::Dragger::getConstraints | ( |  | ) |

inline

References _constraints.

Referenced by osgManipulator::CommandManager::disconnect().

## getConstraints() [2/2]

const Constraints & osgManipulator::Dragger::getConstraints | ( |  | ) | const

inline

References _constraints.

## getDraggerActive()

bool osgManipulator::Dragger::getDraggerActive | ( |  | ) | const

inline

References _draggerActive.

## getDraggerCallbacks() [1/2]

DraggerCallbacks & osgManipulator::Dragger::getDraggerCallbacks | ( |  | ) |

inline

References _draggerCallbacks.

Referenced by osgManipulator::CommandManager::disconnect(), and osgManipulator::CommandManager::getConnectedSelections().

## getDraggerCallbacks() [2/2]

const DraggerCallbacks & osgManipulator::Dragger::getDraggerCallbacks | ( |  | ) | const

inline

References _draggerCallbacks.

## getHandleEvents()

bool osgManipulator::Dragger::getHandleEvents | ( |  | ) | const

inline

References _handleEvents.

## getIntersectionMask()

osg::Node::NodeMask osgManipulator::Dragger::getIntersectionMask | ( |  | ) | const

inline

References _intersectionMask.

## getParentDragger() [1/2]

Dragger * osgManipulator::Dragger::getParentDragger | ( |  | ) |

inline

References _parentDragger, and Dragger().

## getParentDragger() [2/2]

const Dragger * osgManipulator::Dragger::getParentDragger | ( |  | ) | const

inline

References _parentDragger, and Dragger().

## handle() [1/2]

virtual bool osgManipulator::Dragger::handle | ( | const osgGA::GUIEventAdapter & | ea,
|  | osgGA::GUIActionAdapter & | aa )

virtual

## handle() [2/2]

virtual bool osgManipulator::Dragger::handle | ( | const PointerInfo & | ,
|  | const osgGA::GUIEventAdapter & | ,
|  | osgGA::GUIActionAdapter & | )

inline virtual

Reimplemented in osgManipulator::CompositeDragger, and osgManipulator::Translate1DDragger.

## inverted()

bool osgManipulator::Dragger::inverted | ( |  | ) | const

Return true if the axis of the Locator are inverted requiring the faces of any cubes used from rendering to be flipped to ensure the correct front/back face is used.

## META_Node()

osgManipulator::Dragger::META_Node | ( | osgManipulator | ,
|  | Dragger | )

References Dragger().

## receive()

virtual bool osgManipulator::Dragger::receive | ( | const MotionCommand & | command | ) |

virtual

## removeConstraint() [1/2]

template<class T>

void osgManipulator::Dragger::removeConstraint | ( | const osg::ref_ptr< T > & | c | ) |

inline

References osg::ref_ptr< T >::get(), and removeConstraint().

Referenced by removeConstraint().

## removeConstraint() [2/2]

void osgManipulator::Dragger::removeConstraint | ( | Constraint * | constraint | ) |

## removeDraggerCallback() [1/2]

template<class T>

void osgManipulator::Dragger::removeDraggerCallback | ( | const osg::ref_ptr< T > & | dc | ) |

inline

References osg::ref_ptr< T >::get(), and removeDraggerCallback().

Referenced by removeDraggerCallback().

## removeDraggerCallback() [2/2]

void osgManipulator::Dragger::removeDraggerCallback | ( | DraggerCallback * | dc | ) |

## removeTransformUpdating()

void osgManipulator::Dragger::removeTransformUpdating | ( | MatrixTransform * | transform | ) |

References osg::MatrixTransform::MatrixTransform().

## setActivationKeyEvent()

void osgManipulator::Dragger::setActivationKeyEvent | ( | int | key | ) |

inline

References _activationKeyEvent.

## setActivationModKeyMask()

void osgManipulator::Dragger::setActivationModKeyMask | ( | unsigned int | mask | ) |

inline

References _activationModKeyMask.

## setActivationMouseButtonMask()

void osgManipulator::Dragger::setActivationMouseButtonMask | ( | unsigned int | mask | ) |

inline

References _activationMouseButtonMask.

## setDraggerActive()

void osgManipulator::Dragger::setDraggerActive | ( | bool | active | ) |

inline

References _draggerActive.

## setHandleEvents()

void osgManipulator::Dragger::setHandleEvents | ( | bool | flag | ) |

## setIntersectionMask()

virtual void osgManipulator::Dragger::setIntersectionMask | ( | osg::Node::NodeMask | intersectionMask | ) |

inline virtual

Set/Get the traversal mask used by this dragger when looking for intersections during event handling. This is useful to "hide" some geometry during event handling.

Reimplemented in osgManipulator::CompositeDragger.

References _intersectionMask.

## setParentDragger()

virtual void osgManipulator::Dragger::setParentDragger | ( | Dragger * | parent | ) |

inline virtual

Set/Get parent dragger. For simple draggers parent points to itself. For composite draggers parent points to the parent dragger that uses this dragger.

Reimplemented in osgManipulator::CompositeDragger.

References _parentDragger, and Dragger().

## setupDefaultGeometry()

virtual void osgManipulator::Dragger::setupDefaultGeometry | ( |  | ) |

inline virtual

Setup default geometry for dragger.

Reimplemented in osgManipulator::RotateCylinderDragger, osgManipulator::RotateSphereDragger, osgManipulator::Scale1DDragger, osgManipulator::Scale2DDragger, osgManipulator::Translate1DDragger, osgManipulator::Translate2DDragger, and osgManipulator::TranslatePlaneDragger.

Referenced by osgManipulator::ScaleAxisDragger::META_OSGMANIPULATOR_Object(), osgManipulator::TabBoxDragger::META_OSGMANIPULATOR_Object(), osgManipulator::TabBoxTrackballDragger::META_OSGMANIPULATOR_Object(), osgManipulator::TabPlaneTrackballDragger::META_OSGMANIPULATOR_Object(), osgManipulator::TrackballDragger::META_OSGMANIPULATOR_Object(), and osgManipulator::TranslateAxisDragger::META_OSGMANIPULATOR_Object().

## traverse()

virtual void osgManipulator::Dragger::traverse | ( | osg::NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Group.

## Member Data Documentation

## _activationKeyEvent

int osgManipulator::Dragger::_activationKeyEvent

protected

Referenced by getActivationKeyEvent(), and setActivationKeyEvent().

## _activationModKeyMask

unsigned int osgManipulator::Dragger::_activationModKeyMask

protected

Referenced by getActivationModKeyMask(), and setActivationModKeyMask().

## _activationMouseButtonMask

unsigned int osgManipulator::Dragger::_activationMouseButtonMask

protected

Referenced by getActivationMouseButtonMask(), and setActivationMouseButtonMask().

## _activationPermittedByKeyEvent

bool osgManipulator::Dragger::_activationPermittedByKeyEvent

protected

## _activationPermittedByModKeyMask

bool osgManipulator::Dragger::_activationPermittedByModKeyMask

protected

## _activationPermittedByMouseButtonMask

bool osgManipulator::Dragger::_activationPermittedByMouseButtonMask

protected

## _constraints

Constraints osgManipulator::Dragger::_constraints

protected

Referenced by getConstraints(), and getConstraints().

## _draggerActive

bool osgManipulator::Dragger::_draggerActive

protected

Referenced by getDraggerActive(), and setDraggerActive().

## _draggerCallbacks

DraggerCallbacks osgManipulator::Dragger::_draggerCallbacks

protected

Referenced by getDraggerCallbacks(), and getDraggerCallbacks().

## _handleEvents

bool osgManipulator::Dragger::_handleEvents

protected

Referenced by getHandleEvents().

## _intersectionMask

osg::Node::NodeMask osgManipulator::Dragger::_intersectionMask

protected

Referenced by getIntersectionMask(), and setIntersectionMask().

## _parentDragger

Dragger* osgManipulator::Dragger::_parentDragger

protected

Referenced by getParentDragger(), getParentDragger(), and setParentDragger().

## _pointer

osgManipulator::PointerInfo osgManipulator::Dragger::_pointer

protected

## _selfUpdater

osg::ref_ptr<DraggerCallback> osgManipulator::Dragger::_selfUpdater

protected

The documentation for this class was generated from the following file:

- Dragger